/* create */
function inspectorViewNew() {
	lGo('newViewWin');
	_inspectorData=null;

	var parent=document.getElementById('newViewWin');
	var div=oFindChild(parent, 'DIV', 'newViewResult');
	if (!div) return;

	while (div.childNodes.length > 0)
		div.removeChild(div.childNodes[0]);

	var form=document.forms['form_viewnew'];
	if (form) {
		try{
			form['name'].value='new_view';
			form['temp'].checked=form['temp'].defaultChecked=false;
			form['query'].value='SELECT ..';
			form['name'].focus();
			form['name'].select();
		}catch(e){}
	}
}

function inspectorViewNewSubmit(showSql) {
	var form=document.forms['form_viewnew'];
	if (!form) return false;
	if (!trim(form['name'].value)) {
		alert('Insert new view\'s name.');
		form['name'].focus();
		return;
	}
	if (!showSql && !confirm('Create new view?')) return false;

	var newName=form['name'].value;
	var temp=(form['temp'].checked == true)?'TEMP ':'';

	var sql='CREATE '+temp+'VIEW "'+trim(newName)+'" AS '+(form['query'].value.replace(/;\s*$/, ''));

	if (showSql) return dbShowSQL(sql);

	dbExecCommand(sql, inspectorViewNewResponse);

	return false;
}

function inspectorViewNewResponse(dbRes) {
	if (dbRes) {
		inspectorDdlClear();
		dbExecCommand('show table', inspectorTableListDraw);
		lHide();
	}
}

function inspectorViewNewFetch() {
	var form=document.forms['form_viewnew'];
	if (!form) return false;

	dbExecCommand('SELECT * FROM ('+(form['query'].value.replace(/;\s*$/, ''))+') LIMIT 50', inspectorViewNewFetchResponse);
}

function inspectorViewNewFetchResponse(dbRes) {
	var parent=document.getElementById('newViewWin');
	var div=oFindChild(parent, 'DIV', 'newViewResult');
	if (!parent || !div) return;

	while (div.childNodes.length > 0)
		div.removeChild(div.childNodes[0]);

	var grid=new boxGrid();
	if (dbRes.columns && dbRes.columns[0] && dbRes.columns[0].columnname)
		grid.header=dbRes.columns[0].columnname;

	div.appendChild(grid.draw());

	if (dbRes.row) {
		for (var i=0; i < dbRes.row.length; i++)
			grid.appendData(dbRes.row[i].data);
	}
}
